<script setup lang="ts">
import { computed, onMounted, reactive, ref, watch } from "vue";
import { useWorkflowStore } from "@/stores/workflows.ts";
import {
  ParameterVisibility,
  DocumentationEnum,
  type ParameterVisibilityMapping,
} from "@/client/types.gen.ts";
import { md5 } from "@/utils/md5";
import Sortable from "sortablejs";
import ParameterSchemaDescriptionComponent from "@/components/parameter-schema/ParameterSchemaDescriptionComponent.vue";
import { useNameStore } from "@/stores/names.ts";
import type { ClowmInfo } from "@/types/ClowmInfo.ts";
import { Toast, Tooltip } from "bootstrap";
import BootstrapToast from "@/components/BootstrapToast.vue";

const props = defineProps<{
  versionId: string;
  workflowId: string;
  modeId?: string;
}>();

const formState = reactive<{
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  schema: Record<string, any>;
  clowmInfo?: ClowmInfo;
  parameterVisibility: ParameterVisibilityMapping;
  loadSchema: boolean;
  deleted: boolean;
}>({
  schema: {},
  parameterVisibility: {},
  loadSchema: true,
  clowmInfo: undefined,
  deleted: false,
});

const workflowRepository = useWorkflowStore();
const nameRepository = useNameStore();

watch(
  () => formState.schema,
  (newSchema, oldSchema) => {
    if (newSchema != oldSchema) {
      formState.parameterVisibility = computeInitialMapping(newSchema);
    }
  },
);

const simpleListElement = ref<HTMLUListElement | undefined>(undefined);
const advancedListElement = ref<HTMLUListElement | undefined>(undefined);
const expertListElement = ref<HTMLUListElement | undefined>(undefined);
const invisibleListElement = ref<HTMLUListElement | undefined>(undefined);
let successToast: Toast | undefined = undefined;

const parameters = computed<string[]>(() => {
  const a = Object.keys(formState.schema["properties"] ?? {});
  const bla =
    formState.schema["definitions"] ?? formState.schema["$defs"] ?? {};
  return a.concat(
    Object.keys(bla)
      .map((groupName) => Object.keys(bla[groupName]["properties"] ?? {}))
      .flat(),
  );
});
const existingMapping = computed<boolean>(
  () =>
    Object.keys(
      workflowRepository.versionMapping[props.versionId]?.parameter_extension
        ?.parameter_visibility ?? {},
    ).length > 0,
);

function deleteVisibilityMapping() {
  workflowRepository
    .updateWorkflowExtension(props.workflowId, props.versionId, {
      ...(workflowRepository.versionMapping[props.versionId]
        .parameter_extension ?? {}),
      parameter_visibility: undefined,
    })
    .then(() => {
      formState.deleted = true;
      formState.parameterVisibility = computeInitialMapping(formState.schema);
      successToast?.show();
    });
}

function saveVisibilityMapping() {
  workflowRepository
    .updateWorkflowExtension(props.workflowId, props.versionId, {
      ...(workflowRepository.versionMapping[props.versionId]
        .parameter_extension ?? {}),
      parameter_visibility: formState.parameterVisibility,
    })
    .then(() => {
      formState.deleted = false;
      successToast?.show();
    });
}

function computeInitialMapping(
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  schema: Record<string, any>,
): ParameterVisibilityMapping {
  const mapping: ParameterVisibilityMapping = {};
  const groups = schema["definitions"] ?? schema["$defs"] ?? {};
  for (const groupName of Object.keys(groups)) {
    const group = groups[groupName];
    const anyOfDeps: string[] = (group["anyOf"] ?? [])
      .map((dep: Record<string, string[]>) => dep["required"])
      .flat();
    const oneOfDeps: string[] = (group["oneOf"] ?? [])
      .map((dep: Record<string, string[]>) => dep["required"])
      .flat();
    const requiredDeps: string[] = group["required"] ?? [];
    const temp = group["dependentRequired"] ?? group["dependencies"] ?? {};
    const parameterDeps: string[] = Object.keys(temp)
      .map((param) => temp[param])
      .flat();

    for (const paramName of Object.keys(group["properties"] ?? {})) {
      const param = group["properties"][paramName];
      if (
        anyOfDeps.includes(paramName) ||
        oneOfDeps.includes(paramName) ||
        requiredDeps.includes(paramName) ||
        parameterDeps.includes(paramName)
      ) {
        mapping[paramName] = ParameterVisibility.SIMPLE;
      } else if (!(param["hidden"] ?? false)) {
        mapping[paramName] = ParameterVisibility.ADVANCED;
      } else {
        mapping[paramName] = ParameterVisibility.EXPERT;
      }
    }
  }
  for (const paramName of Object.keys(schema["properties"] ?? {})) {
    mapping[paramName] =
      (schema["properties"][paramName]["hidden"] ?? false)
        ? ParameterVisibility.EXPERT
        : ParameterVisibility.ADVANCED;
  }
  return mapping;
}

onMounted(() => {
  formState.loadSchema = true;
  successToast = Toast.getOrCreateInstance("#edit-visibility-toast");
  workflowRepository
    .fetchWorkflowDocumentation(
      props.workflowId,
      props.versionId,
      DocumentationEnum.PARAMETER_SCHEMA_JSON,
      props.modeId,
    )
    .then((schema) => {
      formState.schema = schema;
    })
    .then(() => workflowRepository.fetchWorkflow(props.workflowId, true))
    .then(() => {
      if (
        Object.keys(
          workflowRepository.versionMapping[props.versionId]
            ?.parameter_extension?.parameter_visibility ?? {},
        ).length > 0
      ) {
        formState.parameterVisibility =
          workflowRepository.versionMapping[
            props.versionId
          ]!.parameter_extension!.parameter_visibility!;
      }
    })
    .finally(() => {
      formState.loadSchema = false;
    });
  workflowRepository
    .fetchWorkflowDocumentation(
      props.workflowId,
      props.versionId,
      DocumentationEnum.CLOWM_INFO_JSON,
      props.modeId,
    )
    .then((info) => {
      formState.clowmInfo = info;
    });
  if (simpleListElement.value != undefined) {
    new Sortable(simpleListElement.value, {
      group: "shared",
      animation: 150,
      sort: false, // To disable sorting: set sort to false
      onAdd: (evt) => {
        formState.parameterVisibility[
          (evt.item as HTMLLIElement).innerText.replace(/\.\u200B/g, ".")
        ] = ParameterVisibility.SIMPLE;
      },
    });
  }
  if (advancedListElement.value != undefined) {
    new Sortable(advancedListElement.value, {
      group: "shared",
      animation: 150,
      sort: false, // To disable sorting: set sort to false
      onAdd: (evt) => {
        formState.parameterVisibility[
          (evt.item as HTMLLIElement).innerText.replace(/\.\u200B/g, ".")
        ] = ParameterVisibility.ADVANCED;
      },
    });
  }
  if (expertListElement.value != undefined) {
    new Sortable(expertListElement.value, {
      group: "shared",
      animation: 150,
      sort: false, // To disable sorting: set sort to false
      onAdd: (evt) => {
        formState.parameterVisibility[
          (evt.item as HTMLLIElement).innerText.replace(/\.\u200B/g, ".")
        ] = ParameterVisibility.EXPERT;
      },
    });
  }
  if (invisibleListElement.value != undefined) {
    new Sortable(invisibleListElement.value, {
      group: "shared",
      animation: 150,
      sort: false, // To disable sorting: set sort to false
      onAdd: (evt) => {
        formState.parameterVisibility[
          (evt.item as HTMLLIElement).innerText.replace(/\.\u200B/g, ".")
        ] = ParameterVisibility.INVISIBLE;
      },
    });
  }
  document
    .querySelector("#editVisibilityButtons")
    ?.querySelectorAll('[data-bs-toggle="tooltip"]')
    ?.forEach((tooltipTriggerEl) =>
      Tooltip.getOrCreateInstance(tooltipTriggerEl),
    );
});
</script>

<template>
  <bootstrap-toast toast-id="edit-visibility-toast"
    >Successfully
    <template v-if="formState.deleted">deleted</template>
    <template v-else>edited</template>
    parameter visibility.
  </bootstrap-toast>
  <div class="d-flex justify-content-between border-bottom mb-4 pb-2">
    <h2 class="w-fit">
      Edit parameter visibility of
      {{ nameRepository.getName(props.workflowId) }}@{{
        nameRepository.getName(props.versionId)
      }}
    </h2>
  </div>
  <div class="row mb-2" style="max-height: 500px">
    <div class="col-3 text-center">
      <h5>Simple</h5>
      <div>Parameters that should be visible in the simple view mode</div>
      <ul
        ref="simpleListElement"
        class="list-group border p-1 border-dashed overflow-auto"
        style="height: 300px"
      >
        <li
          v-for="param in parameters.filter(
            (p) =>
              formState.parameterVisibility[p] === ParameterVisibility.SIMPLE,
          )"
          :id="`simple-${md5(param)}`"
          :key="`simple-${md5(param)}`"
          class="list-group-item text-break"
        >
          {{ param.replace(/\./g, ".\u200B") }}
        </li>
      </ul>
    </div>
    <div class="col-3 text-center">
      <h5>Advanced</h5>
      <div>Parameters that should be visible in the advanced view mode</div>
      <ul
        ref="advancedListElement"
        class="list-group border p-1 border-dashed overflow-auto"
        style="height: 300px"
      >
        <li
          v-for="param in parameters.filter(
            (p) =>
              formState.parameterVisibility[p] === ParameterVisibility.ADVANCED,
          )"
          :id="`advanced-${md5(param)}`"
          :key="`advanced-${md5(param)}`"
          class="list-group-item text-break"
        >
          {{ param.replace(/\./g, ".\u200B") }}
        </li>
      </ul>
    </div>
    <div class="col-3 text-center">
      <h5>Expert</h5>
      <div>Parameters that should be visible in the expert view mode</div>
      <ul
        ref="expertListElement"
        class="list-group border p-1 border-dashed overflow-auto"
        style="height: 300px"
      >
        <li
          v-for="param in parameters.filter(
            (p) =>
              formState.parameterVisibility[p] === ParameterVisibility.EXPERT,
          )"
          :id="`expert-${md5(param)}`"
          :key="`expert-${md5(param)}`"
          class="list-group-item text-break"
        >
          {{ param.replace(/\./g, ".\u200B") }}
        </li>
      </ul>
    </div>
    <div class="col-3 text-center">
      <h5>Invisible</h5>
      <div>Parameters that never should be visible or editable by the user</div>
      <ul
        ref="invisibleListElement"
        class="list-group border p-1 border-dashed overflow-auto"
        style="height: 300px"
      >
        <li
          v-for="param in parameters.filter(
            (p) =>
              formState.parameterVisibility[p] ===
              ParameterVisibility.INVISIBLE,
          )"
          :id="`invisible-${md5(param)}`"
          :key="`invisible-${md5(param)}`"
          class="list-group-item text-break"
        >
          {{ param.replace(/\./g, ".\u200B") }}
        </li>
      </ul>
    </div>
  </div>
  <div id="editVisibilityButtons" class="mb-2">
    <button
      type="button"
      class="btn btn-success btn-lg"
      data-bs-toggle="tooltip"
      data-bs-title="Save the parameter visibility setting"
      @click="saveVisibilityMapping"
    >
      Save
    </button>
    <button
      type="button"
      class="ms-2 btn btn-primary btn-lg"
      data-bs-toggle="tooltip"
      data-bs-title="Reset the local parameter visibility setting to the default one"
      @click="
        formState.parameterVisibility = computeInitialMapping(formState.schema)
      "
    >
      Reset
    </button>
    <button
      :hidden="!existingMapping"
      type="button"
      class="ms-2 btn btn-danger btn-lg"
      data-bs-toggle="tooltip"
      data-bs-title="Delete the parameter visibility setting permanently"
      @click="deleteVisibilityMapping"
    >
      Delete
    </button>
  </div>
  <h2 class="w-fit">Preview</h2>
  <div class="p-3 border rounded">
    <parameter-schema-description-component
      v-if="Object.keys(formState.schema).length > 0"
      :schema="formState.schema"
      :parameter-visibility="
        Object.keys(formState.parameterVisibility).length > 0
          ? formState.parameterVisibility
          : undefined
      "
      :clowm-info="formState.clowmInfo"
    />
  </div>
</template>

<style scoped>
li:hover {
  cursor: grab;
  background: var(--bs-secondary-bg-subtle);
}

.border-dashed {
  border-style: dashed !important;
}
</style>
